<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.ds-vector.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'de',
  ),
  'this' => 
  array (
    0 => 'ds-vector.reduce.php',
    1 => 'Ds\\Vector::reduce',
  ),
  'up' => 
  array (
    0 => 'class.ds-vector.php',
    1 => 'Ds\\Vector',
  ),
  'prev' => 
  array (
    0 => 'ds-vector.push.php',
    1 => 'Ds\\Vector::push',
  ),
  'next' => 
  array (
    0 => 'ds-vector.remove.php',
    1 => 'Ds\\Vector::remove',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'en',
    'path' => 'reference/ds/ds/vector/reduce.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="ds-vector.reduce" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">Ds\Vector::reduce</h1>
  <p class="verinfo">(PECL ds &gt;= 1.0.0)</p><p class="refpurpose"><span class="refname">Ds\Vector::reduce</span> &mdash; <span class="dc-title">Reduces the vector to a single value using a callback function</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-ds-vector.reduce-description">
  <h3 class="title">Beschreibung</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>Ds\Vector::reduce</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$callback</code></span>, <span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$initial</code><span class="initializer"> = ?</span></span>): <span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span></div>

  <p class="para rdfs-comment">
    Reduces the vector to a single value using a callback function.
  </p>

 </div>


 <div class="refsect1 parameters" id="refsect1-ds-vector.reduce-parameters">
  <h3 class="title">Parameter-Liste</h3>
  <dl>
   
    <dt><code class="parameter">callback</code></dt>

    <dd>
      <div class="methodsynopsis dc-description">
       <span class="methodname"><span class="replaceable">callback</span></span>(<span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$carry</code></span>, <span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$value</code></span>): <span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span></div>

      <dl>
       
        <dt><code class="parameter">carry</code></dt>
        <dd>
         <p class="para">
          The return value of the previous callback, or <code class="parameter">initial</code> if
          it&#039;s the first iteration.
         </p>
        </dd>
       
       
        <dt><code class="parameter">value</code></dt>
        <dd>
         <p class="para">
          The value of the current iteration.
         </p>
        </dd>
       
      </dl>
     </dd>

   
   
    <dt><code class="parameter">initial</code></dt>
    <dd>
     <p class="para">
        The initial value of the carry value. Can be <strong><code><a href="reserved.constants.php#constant.null">null</a></code></strong>.
     </p>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-ds-vector.reduce-returnvalues">
  <h3 class="title">Rückgabewerte</h3>
  <p class="para">
    The return value of the final callback.
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-ds-vector.reduce-examples">
  <h3 class="title">Beispiele</h3>
  <div class="example" id="example-4119">
   <p><strong>Beispiel #1 <span class="function"><strong>Ds\Vector::reduce()</strong></span> with initial value example</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$vector </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #0000BB">2</span><span style="color: #007700">, </span><span style="color: #0000BB">3</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">$callback </span><span style="color: #007700">= function(</span><span style="color: #0000BB">$carry</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">) {<br />    return </span><span style="color: #0000BB">$carry </span><span style="color: #007700">* </span><span style="color: #0000BB">$value</span><span style="color: #007700">;<br />};<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$vector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">reduce</span><span style="color: #007700">(</span><span style="color: #0000BB">$callback</span><span style="color: #007700">, </span><span style="color: #0000BB">5</span><span style="color: #007700">));<br /><br /></span><span style="color: #FF8000">// Iterations:<br />//<br />// $carry = $initial = 5<br />//<br />// $carry = $carry * 1 =  5<br />// $carry = $carry * 2 = 10<br />// $carry = $carry * 3 = 30<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>Das oben gezeigte Beispiel erzeugt
eine ähnliche Ausgabe wie:</p></div>
   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">int(30)</pre>
</div>
   </div>
  </div>
  <div class="example" id="example-4120">
   <p><strong>Beispiel #2 <span class="function"><strong>Ds\Vector::reduce()</strong></span> without an initial value example</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$vector </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #0000BB">2</span><span style="color: #007700">, </span><span style="color: #0000BB">3</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$vector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">reduce</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$carry</span><span style="color: #007700">, </span><span style="color: #0000BB">$value</span><span style="color: #007700">) {<br />    return </span><span style="color: #0000BB">$carry </span><span style="color: #007700">+ </span><span style="color: #0000BB">$value </span><span style="color: #007700">+ </span><span style="color: #0000BB">5</span><span style="color: #007700">;<br />}));<br /><br /></span><span style="color: #FF8000">// Iterations:<br />//<br />// $carry = $initial = null<br />//<br />// $carry = $carry + 1 + 5 =  6<br />// $carry = $carry + 2 + 5 = 13<br />// $carry = $carry + 3 + 5 = 21<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   <div class="example-contents"><p>Das oben gezeigte Beispiel erzeugt
eine ähnliche Ausgabe wie:</p></div>
   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">int(21)</pre>
</div>
   </div>
  </div>
 </div>



</div><?php manual_footer($setup); ?>